package xyz.tbvns.ui.MenuBarTabs;

import imgui.ImGui;
import xyz.tbvns.DataManager;
import xyz.tbvns.Decoder;
import xyz.tbvns.GeometryDash.GeometryDashProcess;
import xyz.tbvns.GeometryDash.Render;
import xyz.tbvns.LevelInfo;
import xyz.tbvns.Main;
import xyz.tbvns.ui.MenuBarTab;
import xyz.tbvns.ui.UIManager;
import xyz.tbvns.ui.Windows.GDRunningErrorWindow;
import xyz.tbvns.ui.Windows.LevelSelector;

public class SaveMenu implements MenuBarTab {
    @Override
    public void render() {
        if (ImGui.beginMenu("Files")) {
            if (ImGui.menuItem("Save", "CTRL S")) {
                try {
                    if (!GeometryDashProcess.isRunning()) {
                        LevelInfo.setLevelString(new Render().fullRender(24));
                        LevelInfo.getLevel().setEncodedLevelString(Decoder.encodeLevel(LevelInfo.getLevelString()));
                        DataManager.saveLevel(LevelInfo.getLevel());
                    } else {
                        UIManager.getActiveUI().put(GDRunningErrorWindow.class, true);
                    }
                } catch (Exception e) {
                    throw new RuntimeException(e);
                }
            }
            ImGui.menuItem("Export", "SHIFT S");
            if (ImGui.menuItem("Open", "O")) {
                UIManager.getActiveUI().put(LevelSelector.class, true);
                Main.modelCache = null;
            }
            ImGui.menuItem("Close", "C");
            ImGui.endMenu();
        }
    }

    @Override
    public int index() {
        return 0;
    }
}
